﻿using System;
using System.Windows;
using System.Windows.Controls;
using Samples;


namespace OnDemand
{
    public partial class Page : UserControl
    {
        private UIElement content = null;
        private TabItem item = null;

        public Page()
        {
            InitializeComponent();
        }


        private void chkNewContent_Click(object sender, RoutedEventArgs e)
        {
            bool shouldDisplay = (sender as CheckBox).IsChecked.Value;  // IsChecked is nullable<bool>

            if (shouldDisplay)
            {
                if (!IsContentAvailable())
                    DownloadContent();
                else
                    ShowContent();
            }
            else
            {
                HideContent();
            }
        }

        private bool IsContentAvailable()
        {
            return (content != null);
        }

        private void DownloadContent()
        {
            IDownloader dl = new Downloader();
            dl.XapDownloaded += new EventHandler<XapEventArgs>(dl_PackageDownloaded);
            dl.LoadAssemblyFromPackage("more.xap", "more.dll", "More.ExtraTab");
        }

        private void dl_PackageDownloaded(object sender, XapEventArgs e)
        {
            content = e.DownloadedContent;
            ShowContent();
        }

        private void HideContent()
        {
            // Pure visual stuff
            this.TabList.Items.Remove(item);
        }

        private void ShowContent()
        {
            if (item == null)
            {
                item = new TabItem();
                item.Header = "Extra tab";
                item.Content = content;
            }
            this.TabList.Items.Add(item);
        }
    }
}
